<?php
/* Autor...:  */
/* Esquema.: TR_Turno.xml */
/* Generado: 2021-09-09 16:57:53 */

/* Metodos de acceso a los campos de la tabla TR_Turno */
abstract class BaseTR_TurnoBN
{
    /* Campos de la tabla */
    private $i_IdTurno;    // IdTurno: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_TurnoDescripcion;    // TurnoDescripcion: ( no definido )
    private $i_TurnoDescHora;    // TurnoDescHora: ( no definido )
    private $i_TurnoDescMin;    // TurnoDescMin: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdTurno */
    public function setIdTurno( $i_IdTurno )
    {
        $this->i_IdTurno = $i_IdTurno;
    }

    /* Obtiene el valor del campo IdTurno */
    public function getIdTurno()
    {
        return $this->i_IdTurno;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo TurnoDescripcion */
    public function setTurnoDescripcion( $s_TurnoDescripcion )
    {
        $this->s_TurnoDescripcion = $s_TurnoDescripcion;
    }

    /* Obtiene el valor del campo TurnoDescripcion */
    public function getTurnoDescripcion()
    {
        return $this->s_TurnoDescripcion;
    }

    /* Establece el valor del campo TurnoDescHora */
    public function setTurnoDescHora( $i_TurnoDescHora )
    {
        $this->i_TurnoDescHora = $i_TurnoDescHora;
    }

    /* Obtiene el valor del campo TurnoDescHora */
    public function getTurnoDescHora()
    {
        return $this->i_TurnoDescHora;
    }

    /* Establece el valor del campo TurnoDescMin */
    public function setTurnoDescMin( $i_TurnoDescMin )
    {
        $this->i_TurnoDescMin = $i_TurnoDescMin;
    }

    /* Obtiene el valor del campo TurnoDescMin */
    public function getTurnoDescMin()
    {
        return $this->i_TurnoDescMin;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdTurno' => $this->getIdTurno(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'TurnoDescripcion' => $this->getTurnoDescripcion(),
            'TurnoDescHora' => $this->getTurnoDescHora(),
            'TurnoDescMin' => $this->getTurnoDescMin(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto TR_TurnoBN desde un RecordSet */
    public static function retrieveByRs( $o_TR_TurnoRs )
    {
        $o_TR_TurnoBN = new TR_TurnoBN();
        $o_TR_TurnoBN->setIdTurno( ( integer ) $o_TR_TurnoRs[ "IdTurno" ] );
        $o_TR_TurnoBN->setIdCompania( ( integer ) $o_TR_TurnoRs[ "IdCompania" ] );
        $o_TR_TurnoBN->setIdSucursal( ( integer ) $o_TR_TurnoRs[ "IdSucursal" ] );
        $o_TR_TurnoBN->setTurnoDescripcion( $o_TR_TurnoRs[ "TurnoDescripcion" ] );
        $o_TR_TurnoBN->setTurnoDescHora( ( integer ) $o_TR_TurnoRs[ "TurnoDescHora" ] );
        $o_TR_TurnoBN->setTurnoDescMin( ( integer ) $o_TR_TurnoRs[ "TurnoDescMin" ] );
        $o_TR_TurnoBN->setEstado( $o_TR_TurnoRs[ "Estado" ] );
        $o_TR_TurnoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_TR_TurnoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_TR_TurnoBN->setUsuarioCreacion( $o_TR_TurnoRs[ "UsuarioCreacion" ] );
        $o_TR_TurnoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_TR_TurnoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_TR_TurnoBN->setUsuarioModificacion( $o_TR_TurnoRs[ "UsuarioModificacion" ] );
        return $o_TR_TurnoBN;
    }
}
?>